' SuperTape for PC-1500/PC-1500A
' Version 16.06.2015
' Heise, ct 3/85 Page 85, see also: ct 4/84 P.21 and
' Fischel, Alles fuer Sharp Computer 9/85 P.31
' Authors: Paul von Perger, Stefan Hundhammer and other
' Universal Loader for Bas2img 6.1 by Torsten Muecker

10: "B" REM * BASIC LOADER *
20: Q=1: INPUT "Supertape(1) +Merge(2)="; Q
25: IF Q<>1 AND Q<>2 PRINT "False choice!": GOTO 20
30: C=710: IF Q=2 LET C=C+50
35: O=1: INPUT "CE-150(1) CE-162E(2)="; O
40: IF O<>1 AND O<>2 PRINT "False choice!": GOTO 35
45: R=&C0: IF O=2 LET R=&55

50: B=&38C5 : REM Basic version: CE155
60: PRINT "Choice RAM CE-1xx/PC-1500A"
70: P=2: INPUT "1:51 2:55 3:59 4:60 5:A>"; P
80: ON P GOTO "CE151", "CE155", "CE159", "CE160", "PC1500A"
90: PRINT "Choice 1-5 only!": GOTO 60

110: "CE151" D=&0800, H=&08, L=0
116: CS=88307+R: IF Q=2 LET CS=CS+8107
118: GOTO "W"

120: "CE155" D=0, H=0, L=0
126: CS=88067+R: IF Q=2 LET CS=CS+8099
128: GOTO "W"

130: "CE159" D=-&1800, H=-&18, L=0
136: CS=87347+R: IF Q=2 LET CS=CS+8075
138: GOTO "W"

140: "CE160" D=-&3800, H=-&38, L=0
146: CS=86387+R: IF Q=2 LET CS=CS+8043
148: GOTO "W"

150: "PC1500A" D=&433C, H=INT(D/256), L=D-H*256, H=H+256: REM Flag H>256
156: CS=91112+R: IF Q=2 LET CS=CS+8226
'158 GOTO "W"

200: REM Write MC
210: "W" RESTORE :J=-1
220: A=B+D, E=A+C: PRINT "START ADR:"; A

230: FOR A=A TO E
240:  IF J<0 READ I: GOTO 260
250:   J=-1
260:  IF I<256 POKE A,I: GOTO 300
270:   REM PC-1500A Address
280:   J=I-256: READ I: IF I>255 LET I=I-256, J=J+1
290:   POKE A,J
300:  CS=CS-PEEK A
310: NEXT A

320: IF CS<>0 PRINT "CHECKSUM ERROR !": END
325: IF PEEK &C5BD = 129 LET A=A+1
330: PRINT "END ADR+1="; A
340: PRINT "CLOAD RSV with CALL Adr!"
350: END

380:  REM M CODE
'         38C5
3812: DATA                  &66,&E9,&7B,&92, &00,&FD,&A8,&28, &6A,&3F,&8C,&07
'         38D1
3813: DATA 7,&B5,&16,&BE, &39+H,1+L,&88,&A, &D1,&D1,&A4,&FD, &2A,&BE,&39+H,1+L
'         38E1
3814: DATA &18,&1A,&D1,&D1, &38,7,&45,&BE, &39+H,1+L,&DF,&62, &A2,&28,&93,&B
'         38F1
3815: DATA &FD,&18,4,&BE, &39+H,1+L,&8C,&C, &C,&84,&BE,&39+H, 1+L,&CD,&A6,&C
'         3901
3900: DATA &FB,&D1,&FD,&C8, &A5,&7B,&92,&81, &03,&54,&8E,&03, &BD,&45,&F9,&FD
'         3911
3901: DATA &AE,&F0,&07,&CD, &A6,&CD,&A6,&BE, &E4,&56,&38,&06, &BD,&45,&AE,&7B
'         3921
3902: DATA &92,&FD,&AE,&F0, 7,6,&FD,&8A, &DF,&89,1,&9A, &DD,6,&F9,&CD
'         3931
3903: DATA &A6,&9B,&32,&68, 0,&6A,0,&9A, &BE,&39+H,&74+L,&F9, &BE,&39+H,&A9+L,&41
'         3941
3904: DATA &D1,&B5,&FF,&62, &A2,&28,&81,&15, &9E,&F,&BE,&39+H, &74+L,&F9,&BE,&39+H
'         3951
3905: DATA &A9+L,&F7,&89,&1D, &B5,&FF,&62,&A2, &28,&81,&02,&9E, &10,&FD,&18,&BE
'         3961
3906: DATA &39+H,&A9+L,6,&89, &C,&C,&C,&C, &38,&BE,&39+H,&A9+L, &86,&89,2,&F9
'         3971
3907: DATA &9A,&FB,&9A,&66, &FD,&A8,&28,&B5, 0,&BB,1,&BE, &39+H,&DC+L,&B7,&16
'         3981
3908: DATA &99,9,&38,&6A, 9,&8C,&C,&F9, &BE,&39+H,&A9+L,&B7, &16,&99,&16,&88
'         3991
3909: DATA &0C,&8E,&03,&58, 0,7,&D1,&D1, &D1,&BE,&39+H,&A9+L, &B7,&16,&9B,&D
'         39A1
3910: DATA &A6,&99,&2C,&5A, &00,&FD,&2A,&9A, &B5,&80,&FD,&C8, &FD,&98,&58,&F0
'         39B1
3911: DATA &5A,&0F,&B5,&04, &FD,&1F,&89,&06, &FD,&1F,&9B,&04, &8E,&06,&FD,&1F
'         39C1
3912: DATA &99,&04,&B9,&00, &FD,&1A,&A7,&7B, &92,&AE,&7B,&92, &89,&03,&F9,&8E
'         39D1
3913: DATA &02,&54,&FB,&FD, &8A,&D1,&81,&01, &9A,&CD,&A6,&BE, &E4,&56,&9E,&36
'         39E1
3940: DATA &2A,&BE,&3B+H,&2B+L, &BE,&3B+H,&46+L,&8B
3941: DATA                                 3,&BA,&3B+H,&18+L, &BE,&DF,&FA,&81
'         39F1
3950: DATA &3E,&64,&64,&FD, &BE,&58,&7B,&5A, &71,&04,&51,&84, &51,&24,&51,&A4
'         3A01
4000: DATA &1E,&FD,&88,&FD, &A8,&BE,&3B+H,&6F+L, &B5,&44,&FD,&AE, &F0,7,&68,0
'         3A11
4010: DATA &6A,&80,&CD,&AC, &48,&7B,&4A,&60, &68,&00,&6A,&19, &B5,&2A,&BE,&38+H
'         3A21
4020: DATA &C5+L,&FD,&2A,&FD, &A,&B5,&C5,&BE
4021: DATA                             &38+H,&C5+L,&BE,&3B+H, &5A+L,&FD,&81,&F9
'         3A31
4030: DATA &9A,&2A,&B5,1, &8E,3,&2A,&B5, 0,&AE,&7B,&93, &BE,&3B+H,&2B+L,&BE
'         3A41
4040: DATA &3B+H,&46+L,&89,&D3, &BE,&3B+H,&6A+L,&FD, &48,&CD,&CA,0, &FD,&BE,&B5,&55
'         3A51
4050: DATA &AE,&79,&DA,&68, &3B+H,&6A+L,&1D+0,&CD, &F6,&79,&DB,&B5, 2,&FD,&AE,&F0
'         3A61
4060: DATA &0A,&FD,&81,&48, &7B,&4A,&79,&68, 0,&6A,&19,&B5, &2A,&BE,&39+H,&39+L
'         3A71
4070: DATA &83,&94,&F2,&68, &7B,&6A,&79,&B5, &10,&E9,&78,&75, &00,&CD,&92,&58
'         3A81
4080: DATA &7B,&5A,&60,&48, &7B,&4A,&79,&6A, &0F,&55,&B7,&3F, &8B,&07,&B7,&2A
'         3A91
4090: DATA &8B,&06,&07,&89, &03,&44,&88,&0F, &8B,&0C,&B5,&20, &BE,&ED,&4D,&B5
'         3AA1
4100: DATA &3F,&BE,&ED,&4D, &9E,&43,&5A,&89, &55,&68,&78,&D9, &83,&62,&55,&0A
'         3AB1
4110: DATA &55,&08,&55,&2A, &55,&28,&ED,&7B, &93,&01,&8B,&0C, &B5,&C5,&BE,&39+H
'         3AC1
4120: DATA &4B+L,&83,&43,&BE+0, &3B+H,&4E+L,&F9,&9A
4121: DATA                                   &FD,&A8,&BE,&D0, &D,&BE,&D0,&91
'         3AD1
4130: DATA &CD,&CC,&65,&FD, &2A,&FD,&A8,&66, &F9,&04,&22,&0A, &84,&A2,&08,&68
'         3AE1
4140: DATA &16,&83,&2D,&BE, &DF,&DB,&81,&28, &EB,&7B,&93,&02, &CD,&CA,&67,&CD
'         3AF1
4150: DATA &CC,&65,&CD,&CA, &69,&FD,&2A,&B5, &C5,&BE,&39+H,&39+L, &91,&3B,&CD,&CC
'         3B01
4200: DATA &65,&CD,&CA,&67, &4B,&FF,&68,&2C, &ED,&7B,&93,&01, &8B,&02,&FD,&62
'         3B11
4210: DATA &FD,&A8,&BE,&3B+H, &4E+L,&FD,&2A,&FD, &1A,&FD,&1A,&E0, &B8,&CD,&CC,0
'         3B21
4220: DATA &FD,&4E,&ED,&7B, &93,&02,&9B,&65, &9E,&2C,&FD,&5A, &48,&7B,&4A,&92
'         3B31
4230: DATA &B5,&00,&43,&4E, &61,&93,&05,&62, &6E,&10,&81,&02, &6A,&0F,&55,&8B
'         3B41
4240: DATA &03,&41,&88,&06, &9A,&A5,&A0,&00, &B7, R ,&68,&1B, &9A,&E9,&79,&DA
'         3B51
4250: DATA &00,&B5,&01,&FD, &AE,&F0,&0A,&FD, &81,&FD,&E9,&F0, &07,&00,&FD,&EB
'         3B61
4260: DATA &B0,&0C,&01,&B5, &05,&BE,&BF,&28, &9A,&FD,&E9,&B0, &0C,&FE,&FD,&E9
'         3B71
4270: DATA &F0,&07,&00,&ED, &78,&6B,&01,&89, &07,&FD,&EB,&F0, &08,&40,&8E,&05
'         3B81
4280: DATA &FD,&E9,&F0,&08, &BF,&B5,&03,&BE, &BF,&28,&9A

' Alles fuer SHARP Computer Heft 9/85 S.31
5000: REM MERGE
'         3B8C
5028: DATA                                               &FD, &88,&FD,&C8,&CC
'         3B91
5029: DATA &65,&FD,&6A,&F6, &7A,&30,&CC,&67, &B5,&01,&FD,&CA, &B5,&FF,&0E,&CA
'         3BA1
5030: DATA &65,&CA,&67,&CA, &69,&FD,&8A,&FD, &A,&BE,&3A+H,&37+L, &FD,&88,&FD,&C8
'         3BB1
5031: DATA &F4,&7A,&30,&FD, &28,&CA,&65,&FD, &8A,&FD,&0A,&FB, &9A


'         3Bx1
'503x: DATA &00,&00,&00,&00, &00,&00,&00,&00, &00,&00,&00,&00, &00,&00,&00,&00

